package de.communardo.confluence.plugins.displaysubspace;

import java.util.Collection;

import com.atlassian.confluence.spaces.Space;

/**
 * 
 * @author Bill Martin
 * 
 */
public class SpaceHierarchy {

    private final TreeNode root;

    public SpaceHierarchy(TreeNodeComparator comparator) {
        this.root = new TreeNode(new Space(), comparator);
    }

    /**
     * 
     * @param node
     *            The space to be inserted.
     * @param parent
     */
    public void insertNode(TreeNode node, TreeNode parent) {
        if (parent == null) {
            root.getChildren().add(node);
        } else {
            parent.getChildren().add(node);
        }
    }

    /**
     * 
     * @return The sorted hierarchy.
     */
    public Collection<TreeNode> getHierarchy() {
        return root.getChildren();
    }

    /**
     * 
     * @param node
     * @return The sorted hierarchy.
     */
    public Collection<TreeNode> getHierarchy(TreeNode node) {
        return node.getChildren();
    }
}