package de.communardo.confluence.plugins.util;

import org.andya.confluence.plugins.metadata.space.SpaceUtils;
import org.andya.confluence.utils.ContentService;

import com.atlassian.confluence.core.ContentPropertyManager;
import com.atlassian.confluence.core.FormatSettingsManager;
import com.atlassian.confluence.spaces.Space;
import com.atlassian.confluence.spaces.SpaceManager;
import com.atlassian.user.UserManager;

public class SubspaceHelper {

    private static ContentService contentService;
    private SpaceManager spaceManager;
    private ContentPropertyManager contentPropertyManager;
    private UserManager userManager;
    private FormatSettingsManager formatSettingsManager;

    public Space getToplevelSpace(String spaceKey) {

        if (spaceKey == null) {
            return null;
        }

        Space parentSpace = getParentSpace(spaceKey);
        if (parentSpace == null) {
            return spaceManager.getSpace(spaceKey);
        } else {
            return getToplevelSpace(parentSpace.getKey());
        }
    }

    public Space getParentSpace(String spaceKey) {
        return SpaceUtils.getParentSpace(getContentService(), spaceManager.getSpace(spaceKey));
    }

    private ContentService getContentService() {
        if (contentService == null) {
            contentService = new ContentService(contentPropertyManager, spaceManager, userManager,
                    formatSettingsManager);
        }
        return contentService;
    }

    public void setSpaceManager(SpaceManager spaceManager) {
        this.spaceManager = spaceManager;
    }

    public SpaceManager getSpaceManager() {
        return spaceManager;
    }

    public void setContentPropertyManager(ContentPropertyManager contentPropertyManager) {
        this.contentPropertyManager = contentPropertyManager;
    }

    public ContentPropertyManager getContentPropertyManager() {
        return contentPropertyManager;
    }

    public void setUserManager(UserManager userManager) {
        this.userManager = userManager;
    }

    public UserManager getUserManager() {
        return userManager;
    }

    public void setFormatSettingsManager(FormatSettingsManager formatSettingsManager) {
        this.formatSettingsManager = formatSettingsManager;
    }

    public FormatSettingsManager getFormatSettingsManager() {
        return formatSettingsManager;
    }

}
